SystemOrganization addCategory: #'GT-Metaceller-Tests'!

TestCase subclass: #GTMetacellerTestCase
	instanceVariableNames: 'testConfigurationClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

GTMetacellerTestCase subclass: #GTMetacellerConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:42'!
testChildren
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self assert: configuration children isEmpty! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:42'!
testMainProject
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self deny: configuration mainProject hasAttributes! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:42'!
testProjects
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self assert: configuration projects size equals: 3! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:50'!
testShortName
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self assert: configuration shortName equals: 'TestForMetaceller'! !

GTMetacellerTestCase subclass: #GTMetacellerModelTest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerModelTest methodsFor: 'setUp' stamp: 'DiegoLont 3/14/2014 13:33'!
createOnSetup
	^false! !

!GTMetacellerModelTest methodsFor: 'setUp' stamp: 'DiegoLont 3/14/2014 13:45'!
setUp
	super setUp.
	model := GTMetacellerModel new! !

!GTMetacellerModelTest methodsFor: 'tests' stamp: 'DiegoLont 3/14/2014 13:45'!
testCreateClass
	| currentCount |
	currentCount := model configs size.
	self createTestConfigurationClass.
	self assert: model configs size equals: currentCount +1! !

GTMetacellerTestCase subclass: #GTMetacellerPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testPlatformCommon
	| package |
	package := ((GTMetacellerConfiguration on: testConfigurationClass) mainProject version: '0.1') package: 'GT-Metaceller-Model'.
	self assert: package platforms size equals: 1.
	self assert: (package platforms contains: [ :each | each hasSymbol:#'common' ])! !

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testPlatformGemstone
	| package |
	package := ((GTMetacellerConfiguration on: testConfigurationClass) mainProject version: '0.1') package: 'GlamourCore'.
	self assert: package isNil! !

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:49'!
testPlatformPharo
	| package |
	package := ((GTMetacellerConfiguration on: testConfigurationClass) mainProject version: '0.1') package: 'GlamourTools'.
	self assert: package platforms size equals: 1.
	self assert: (package platforms includes: (GTPlatformDescription onSymbol: #'pharo'))! !

GTMetacellerTestCase subclass: #GTMetacellerProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:53'!
testCreateVersion
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	(mainProject createSnapshotVersion: '0.2' baseline: '0.1-baseline').
	self assert: (testConfigurationClass includesSelector: #version02:)! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 3/24/2014 13:05'!
testGemstone
	| project version |
	project := (GTMetacellerConfiguration on: testConfigurationClass) projectFor: #gemstone.
	version := project version: '0.1-baseline'.
	self assert: version packages size equals: 3.
	self assert: version projects size equals: 1! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testProjects
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject projects size equals: 3! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testSymbols
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject platformSymbols size equals: 3.
	self assert: (mainProject platformSymbols includes: #'common').
	self assert: (mainProject platformSymbols includes: #'gemstone').
	self assert: (mainProject platformSymbols includes: #'pharo').! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testVersions
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject versions size equals: 2.
	self assert: (mainProject versions contains: [ :each | each name  ='0.1-baseline' ]).
	self assert: (mainProject versions contains: [ :each | each name ='0.1' ])
! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 9/18/2013 16:02'!
createBaseline01
	testConfigurationClass
		compile: 'baseline01: aSpec
	<version: ''0.1-baseline''>
	aSpec for: #common do: [ 
		aSpec blessing: #''baseline''.
		aSpec description: ''Just a testDescription''.
		aSpec repository: ''http://smalltalkhub.com/mc/Moose/GToolkit/main''.

		aSpec package: ''GT-Metaceller-Model'';
			package: ''GT-Metaceller-Glamour'' with: [ 
				aSpec requires: #( ''GT-Metaceller-Model'' ) ];
			package: ''GT-Metaceller-Tests'' with: [ 
				aSpec requires: #( ''GT-Metaceller-Model'' ) ].
		aSpec
			group: ''Core'' with: #( ''GT-Metaceller-Model'' );
			group: ''Tests'' with: #( ''GT-Metaceller-Tests'' );
			group: ''Glamour'' with: #( ''GT-Metaceller-Glamour'' );
			group: ''All'' with: #( ''Tests'' ''Glamour'' ) ].
	
	aSpec for: #gemstone do: [ 
		aSpec project: ''GlamourCore'' with: [
				aSpec
					className: ''ConfigurationOfGlamour'';
					file: ''ConfigurationOfGlamour'';
					version: #development;
					loads: #(''Core'');
					repository: ''http://www.smalltalkhub.com/mc/Moose/Glamour/main'' ].
		aSpec package: ''GT-Metaceller-Glamour'' with: [ 
			aSpec requires: #( ''GlamourCore'' ) ] ].

	aSpec for: #pharo do: [ 
		aSpec project: ''GlamourTools'' with: [
				aSpec
					className: ''ConfigurationOfGToolkit'';
					file: ''ConfigurationOfGToolkit'';
					version: #development;
					loads: #( ''GT-Inspector'' );
					repository: ''http://www.smalltalkhub.com/mc/Moose/Glamour/main'' ].
		aSpec package: ''GT-Metaceller-Glamour'' with: [ 
			aSpec requires: #( ''GlamourTools'' ) ] ]' classified: 'baselines'.
	testConfigurationClass
		compile: 'development: spec
	<symbolicVersion: #development>
	spec for: #common version: ''0.1-baseline''' classified: 'symbolicVersions'.
	testConfigurationClass
		compile: 'version01: aSpec
	<version: ''0.1'' imports: #( ''0.1-baseline'')>
	aSpec for: #''common'' do: [ 
		aSpec blessing: #''development''.
		aSpec description: ''Just the development branch, so no version specified for now.''.
		aSpec author: ''Diego Lont'' ]' classified: 'versions'! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 3/14/2014 13:32'!
createOnSetup
	^true! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 3/21/2014 15:48'!
createTestConfigurationClass
	testConfigurationClass := Object
		subclass: #ConfigurationOfTestForMetaceller
		instanceVariableNames: 'project'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'GT-ConfigurationOfMetaceller-Tests'.
	testConfigurationClass class
		compile: 'project
	^self new project' classified: 'metacello'.
	testConfigurationClass class
		compile: 'ensureMetacello
	Smalltalk at: #MetacelloProject ifAbsent: [
		Gofer new
				url: ''http://seaside.gemtalksystems.com/ss/metacello/'';
				addPackage: ''ConfigurationOfMetacello'';
				load.
		(Smalltalk at: #ConfigurationOfMetacello) loadLatestVersion ]' classified: 'metacello'.
	testConfigurationClass class
		compile: 'isMetacelloConfig	
	^true'.
	testConfigurationClass 
		compile: 'project
	^ project ifNil: [ | constructor |
		self class ensureMetacello.
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project ]' classified: 'metacello'.
		! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 3/14/2014 13:32'!
setUp
	super setUp.
	self createOnSetup ifTrue: [
		self createTestConfigurationClass.
		self createBaseline01 ]! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 3/14/2014 13:32'!
tearDown
	super tearDown.
	testConfigurationClass ifNotNil: [ testConfigurationClass removeFromSystem ]
	
! !

GTMetacellerTestCase subclass: #GTMetacellerVersionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerVersionTest methodsFor: 'tests' stamp: 'DiegoLont 3/24/2014 12:24'!
assertItem: anItem equals: anItem2
	self assert: anItem class equals: anItem2 class.
	self assert: anItem itemName equals: anItem2 itemName! !

!GTMetacellerVersionTest methodsFor: 'tests' stamp: 'DiegoLont 3/24/2014 12:19'!
assertVersion: aVersion equals: aVersion2
	self assert: aVersion packagesAndProjects size equals: aVersion2 packagesAndProjects size.
	aVersion packagesAndProjects do: [ :each |
		self assertItem: each equals: (aVersion2 itemFor: each itemName) ].
	self assert: aVersion category equals: aVersion2 category.
	self assert: aVersion repositorySpecs list size equals: aVersion2 repositorySpecs list size.
	self assert: aVersion repositorySpecs list first spec description equals: aVersion2 repositorySpecs list first spec description! !

!GTMetacellerVersionTest methodsFor: 'tests' stamp: 'DiegoLont 3/24/2014 12:12'!
testBaselineCopy
	| mainProject version1 version2 |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	version1 := mainProject version:'0.1-baseline'.
	version1 saveAs: '0.2-baseline'.
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject versions size equals: 3.
	self assert: (mainProject versions contains: [ :each | each name ='0.2-baseline' ]).
	version2 := mainProject version: '0.2-baseline'.
	self assertVersion: version1 equals: version2! !

!GTMetacellerVersionTest methodsFor: 'tests' stamp: 'DiegoLont 3/24/2014 12:26'!
testBaselineGemstoneCopy
	| config version gemstoneVersion1 gemstoneVersion2 |
	config := (GTMetacellerConfiguration on: testConfigurationClass).
	version := config mainProject version:'0.1-baseline'.
	gemstoneVersion1 := (config projectFor: #gemstone) version:'0.1-baseline'.
	version saveAs: '0.2-baseline'.
	config := (GTMetacellerConfiguration on: testConfigurationClass).
	gemstoneVersion2 := (config projectFor: #gemstone) version:'0.2-baseline'.
	self assertVersion: gemstoneVersion1 equals: gemstoneVersion2! !

!GTMetacellerVersionTest methodsFor: 'tests' stamp: 'DiegoLont 3/24/2014 12:05'!
testVersionCopy
	| mainProject version1 version2 |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	version1 := mainProject version: '0.1'.
	version1 saveAs: '0.2'.
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject versions size equals: 3.
	self assert: (mainProject versions contains: [ :each | each name ='0.2' ]).
	version2 := mainProject version: '0.2'.
	self assert: version2 packagesAndProjects size equals: version1 packagesAndProjects size.
	self assert: version2 category equals: version1 category! !
